<link rel="import" href="../bower_components/polymer/polymer-element.html">
<link rel="import" href="../bower_components/vaadin-dialog/vaadin-dialog.html">
<link rel="import" href="../bower_components/vaadin-button/vaadin-button.html">
<link rel="import" href="../bower_components/vaadin-item/vaadin-item.html">
<link rel="import" href="../bower_components/vaadin-ordered-layout/vaadin-horizontal-layout.html">
<link rel="import" href="../bower_components/iron-form/iron-form.html">

<dom-module id="auth-dialog">
  <template>
    <brum-global-variable key="backendBase" id="backendVariable"></brum-global-variable>
    <vaadin-dialog id="dialog" opened="{{opened}}">
      <template>
        <vaadin-vertical-layout>
          <h4>[[cc(kind)]] authentication</h4>
          <iron-form with-credentials id="form" on-iron-form-response="handleFormResponse">
            <brum-global-variable key="backendBase" value="{{backendBase}}" readonly></brum-global-variable>
            <form method="post" action="[[backendBase]]/[[kind]]/login">
              <vaadin-vertical-layout>
                <vaadin-item>
                  <brum-global-variable key="apiBase" value="{{apiBase}}" readonly></brum-global-variable>
                  <iron-ajax auto with-credentials url="[[apiBase]]/[[kind]]s" last-response="{{result}}"
                             loading="{{loading}}"></iron-ajax>
                  <vaadin-combo-box allow-costum-value required class="full-width" placeholder="handle"
                                    items="[[result.result]]" loading="[[loading]]"
                                    item-value-path="_id" item-label-path="_id" name="id"></vaadin-combo-box>
                </vaadin-item>
                <vaadin-item>
                  <vaadin-text-area class="full-width" placeholder="signature in base64"
                                    name="signature"></vaadin-text-area>
                </vaadin-item>
              </vaadin-vertical-layout>
            </form>
          </iron-form>
          <vaadin-button on-click="authByDialog">Log in</vaadin-button>
        </vaadin-vertical-layout>
      </template>
    </vaadin-dialog>
  </template>
</dom-module>

<script>
  class AuthDialog extends Polymer.Element {
    static get is() {
      return 'auth-dialog';
    }

    // noinspection JSUnusedGlobalSymbols
    static get properties() {
      return {
        opened: {
          type: Boolean,
          notify: true,
        },
        kind: {
          type: String,
        },
      };
    }

    // noinspection JSMethodCanBeStatic
    cc(str) {
      return str[0].toUpperCase() + str.slice(1);
    }

    // noinspection JSUnusedGlobalSymbols
    authByDialog() {
      const form = this.$.dialog.$.overlay.content && this.$.dialog.$.overlay.content.getElementById('form');
      if (!form) {
        throw new Error('Dialog is not open');
      }
      if (form.validate()) {
        form.submit();
      }
    }

    // noinspection JSUnusedGlobalSymbols
    handleFormResponse() {
      // noinspection JSUnusedGlobalSymbols
      this.opened = false;

      // trigger full reload
      const oldBackend = this.$.backendVariable.value;
      this.$.backendVariable.value = '://' + oldBackend; // impossible url...
      this.$.backendVariable.value = oldBackend;
    }
  }

  window.customElements.define(AuthDialog.is, AuthDialog);
</script>